/*  BVI.H
 *
 * 1996-02-28  V 1.0.0
 * 1998-03-14  V 1.0.1
 * 1999-01-21  V 1.1.0
 *
 *  NOTE: Edit this file with tabstop=4 !
 *
 * Copyright 1996-1969 by Gerhard Buergmann
 * Gerhard.Buergmann@altavista.net
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * See file COPYING for information on distribution conditions.
 */

/* defines for filemode */
#define	ERROR				-1
#define REGULAR				0
#define NEW					1
#define DIRECTORY			2
#define CHARACTER_SPECIAL	3
#define BLOCK_SPECIAL		4


#define HEX			0
#define ASCII		1
#define FORWARD		0
#define BACKWARD	1
#define EDIT		1
#define TRUNC		2
#define CR			'\r'
#define NL			'\n'
#define BS			8
#define	ESC			27
#define SEARCH		0
#define REPLACE		1
#ifndef CTRL	
#	define CTRL(n)		n&0x1f
#endif

#ifndef NULL
#	define NULL		((void *)0)
#endif

#ifndef TRUE
#	define TRUE		1
#	define FALSE	0
#endif

#ifdef __MSDOS__
#	define ANSI
#	define PTR		char huge *
#   define DELIM	'\\'
#   define  strncasecmp strnicmp
#   define  strcasecmp	stricmp
#else
#	define PTR		char *
#   define DELIM	'/'
#endif

#define MAXCMD	255
#define BUFFER	1024

#define SKIP_WHITE  while(*cmd!='\0'&&isspace(*cmd))cmd++;

#ifdef DEBUG
	extern FILE *debug_fp;
#endif

#ifndef __GNU_LIBRARY__
	extern	char	*sys_errlist[];
#endif

extern	char	*version;
extern	char    pattern[];
extern	int		maxx, maxy, x, y;
extern	int		filemode, loc;
extern	int		edits, new;
extern	int		AnzAdd;
extern	int		addr_flag;
extern	PTR		mem;
extern	PTR		maxpos;
extern	PTR		pagepos;
extern	PTR		undo_start;
extern	PTR		current_start;
extern  PTR		curpos;
extern	PTR		current;
extern	PTR		start_addr;
extern	PTR		end_addr;
extern	char	*name;
extern	long	filesize, memsize;
extern	int		Anzahl;
extern	PTR		markbuf[];
extern  PTR		last_motion;
extern	long	undo_count;
extern	long	undosize;
extern	char	*undo_buf;
extern	int		repl_count;
extern	char	string[];
extern	char	*shell;

#ifndef S_ISDIR				/* POSIX 1003.1 file type tests. */
#define	S_ISDIR(m)	((m & 0170000) == 0040000)	/* directory */
#define	S_ISCHR(m)	((m & 0170000) == 0020000)	/* char special */
#define	S_ISBLK(m)	((m & 0170000) == 0060000)	/* block special */
#define	S_ISREG(m)	((m & 0170000) == 0100000)	/* regular file */
#define	S_ISFIFO(m)	((m & 0170000) == 0010000)	/* fifo */
#endif


#ifdef ANSI
	long	alloc_buf(long, char **);
	void	do_exit(void), do_shell(void);
	void	badcmd(char *);
	void	docmdline(char *);
	int		doecmd(char *, int);
	int		bregexec(PTR, char *);
	PTR		wordsearch(PTR, char);
	PTR		backsearch(PTR, char);
	PTR		fsearch(PTR, PTR, char *);
	PTR		rsearch(PTR, PTR, char *);
	PTR		end_word(PTR);
	PTR		calc_addr(char **, PTR);
	char	*patcpy(char *, char *, char);
	void	setpage(PTR), msg(char *), emsg(char *), smsg(char *);
	void	do_ft(int), wait_return(void);
	void	usage(void), bvi_init(char *), statpos(void), setcur(void);
	void	toggle(void), scrolldown(int), scrollup(int);
	void	cur_forw(void), cur_back(void), fileinfo(char *);
	void	clearstr(void), clear_marks(void), repaint(void), new_screen(void);
	void	quit(void), sysemsg(char *), do_z(int), stuffin(char *);
	long	edit(int), load(char *);
	int		lineout(void), save(char *, char *, char *, int);
	int		at_least(char *, char *, int);
	int		vgetc(void), xpos(void), enlarge(long);
	int		searching(int, char *), getcmdstr(char *, int), read_rc(char *);
#else
	long	alloc_buf();
	void	do_exit(), do_shell();
	void	badcmd();
	void	docmdline();
	int		doecmd();
	PTR		wordsearch();
	PTR		backsearch();
	int		bregexec();
	PTR		fsearch();
	PTR		rsearch();
	PTR		end_word();
	PTR		calc_addr();
	char	*patcpy();
	void	setpage(), msg(), emsg(), smsg(), wait_return();
	void	usage(), bvi_init(), statpos(), setcur();
	void	do_ft(), toggle(), scrolldown(), scrollup();
	void	cur_forw(), cur_back(), fileinfo();
	void	clearstr(), clear_marks(), new_screen(), repaint();
	void	quit(), sysemsg(), do_z(), stuffin();
	long	edit(), load();
	int		lineout(), save(), at_least(), read_rc();
	int		searching(), getcmdstr(), enlarge();
	int		vgetc(), xpos();
#endif
